import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.regexp.replace";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.regexp.search";
import "core-js/modules/es6.function.name";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { observer, inject } from 'mobx-react';
import ActionButton from './ActionButton';
import Filter from './Filter';
import PropTypes from 'prop-types';
import Drawer from './Drawer';
import withStyles from '@material-ui/core/styles/withStyles';
import classnames from 'classnames';
import grey from '@material-ui/core/colors/grey';
import { Hbox } from './Box';
export var styles = function styles(theme) {
  return {
    clear: _objectSpread({}, theme.typography.caption, {
      padding: 0,
      marginLeft: '10px',
      textDecoration: 'underline'
    }),
    clearDisabled: {
      color: grey[400]
    },
    drawer: {
      height: '75vh'
    }
  };
};
/**
 * A button that when clicked, opens a drawer containing the `Filter` view. Current filters
 * are displayed in the button text.
 */

var FilterButton = (_dec = withStyles(styles, {
  name: 'RSFFilterButton'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(FilterButton, _Component);

  function FilterButton(_ref) {
    var _this;

    var app = _ref.app;

    _classCallCheck(this, FilterButton);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilterButton).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }

      if (!e.defaultPrevented) {
        _this.toggleOpen(true);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "toggleOpen", function (open) {
      _this.setState({
        open: open
      });

      if (open) {
        _this.setState({
          mountDrawer: true,
          open: true
        });
      } else {
        _this.setState({
          open: false
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onViewResultsClick", function () {
      _this.toggleOpen(false);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getFilterList", function () {
      var selectedFacets = _this.props.model.selectedFacets;
      if (!selectedFacets || !selectedFacets.length) return null;
      if (selectedFacets.length > 1) return "".concat(selectedFacets.length, " selected");
      return selectedFacets[0].name;
    });

    var openFilter = app.location.search.indexOf('openFilter') !== -1;
    _this.state = {
      open: openFilter,
      mountDrawer: openFilter
    };
    return _this;
  }

  _createClass(FilterButton, [{
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          classes = _this$props.classes,
          app = _this$props.app,
          model = _this$props.model,
          title = _this$props.title,
          drawerProps = _this$props.drawerProps,
          hideClearLink = _this$props.hideClearLink,
          clearLinkText = _this$props.clearLinkText,
          props = _objectWithoutProperties(_this$props, ["classes", "app", "model", "title", "drawerProps", "hideClearLink", "clearLinkText"]);

      var _this$state = this.state,
          open = _this$state.open,
          mountDrawer = _this$state.mountDrawer;

      var clear = classes.clear,
          clearDisabled = classes.clearDisabled,
          drawer = classes.drawer,
          buttonClasses = _objectWithoutProperties(classes, ["clear", "clearDisabled", "drawer"]);

      var pwaPath = app.location.pathname.replace(/\.amp/, '');
      var pwaSearch = app.location.search || '';
      var queryChar = pwaSearch ? '&' : '?';
      var ampUrl = pwaPath + pwaSearch + queryChar + 'openFilter';
      return React.createElement(Fragment, null, React.createElement(ActionButton, _extends({
        label: title,
        href: app.amp ? ampUrl : null,
        value: this.getFilterList(),
        classes: buttonClasses
      }, props, {
        onClick: this.onClick
      })), !app.amp && React.createElement(Drawer, {
        ModalProps: {
          keepMounted: true
        },
        classes: {
          paper: classes.drawer
        },
        anchor: "bottom",
        title: React.createElement(Hbox, {
          justifyContent: "center"
        }, React.createElement("div", null, title), hideClearLink || model.filters.length === 0 ? null : React.createElement("button", {
          className: classnames((_classnames = {}, _defineProperty(_classnames, clear, true), _defineProperty(_classnames, clearDisabled, model.loading), _classnames)),
          onClick: function onClick() {
            return !model.loading && model.clearAllFilters();
          }
        }, clearLinkText)),
        open: open,
        onRequestClose: this.toggleOpen.bind(this, false)
      }, mountDrawer && React.createElement(Filter, _extends({
        model: model,
        onViewResultsClick: this.onViewResultsClick
      }, drawerProps))));
    }
  }]);

  return FilterButton;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * An instance of `SearchResultModelBase`
   */
  model: PropTypes.object,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * Props for the underlying `Filter` component
   */
  drawerProps: PropTypes.object,

  /**
   * The label for the button and the drawer header.  Defaults to "Filter".
   */
  title: PropTypes.string,

  /**
   * Set to true to hide the clear link that is shown by default when one or more filters
   * is selected.  Defaults to false.
   */
  hideClearLink: PropTypes.bool,

  /**
   * Text for the clear link.  Defaults to "clear all".
   */
  clearLinkText: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  title: 'Filter',
  drawerProps: {},
  hideClearLink: false,
  clearLinkText: 'clear all'
}), _temp)) || _class) || _class) || _class);
export { FilterButton as default };
//# sourceMappingURL=FilterButton.js.map